/*
 * Some structure forward declarations are needed.
 */

/* #define MALLOC_DEBUG */

struct program;
struct function;
struct svalue;
struct sockaddr;

#if defined(__GNUC__) && !defined(lint)
/* #define INLINE inline /not today I want to know what's happening. */
#define INLINE
#else
#define INLINE
#endif

#ifdef BUFSIZ
#    define PROT_STDIO(x) PROT(x)
#else /* BUFSIZ */
#    define PROT_STDIO(x) ()
#endif /* BUFSIZ */

#ifdef __STDC__
#    define PROT(x) x
#else /* __STDC__ */
#    define PROT(x) ()
#endif /* __STDC */

#ifndef MSDOS
#if defined(sun) && defined(__STDC__)
#ifdef BUFSIZ
/* int fprintf(FILE *, char *, ... );  */
/* int fputs(char *, FILE *); */
/* int fputc(char, FILE *); */
/* int fwrite(char *, int, int, FILE *); */
/* int fread(char *, int, int, FILE *); */
#endif
/* int printf(char *, ... ); */
/* int sscanf(char *, char *, ... ); */
/* void perror(char *); */
#endif

#if !defined(AMIGA_UNIX) && !defined(__STDC__)
int read PROT((int, char *, int));
#endif
#ifndef _AIX
char *malloc PROT((unsigned));
char *realloc PROT((char *, unsigned));
#endif
#if !defined(sgi) && !defined(AMIGA_UNIX) && !defined(linux)
/* int mkdir PROT((const char *, int)); */
#endif
int fclose PROT_STDIO((FILE *));
int pclose PROT_STDIO((FILE *));
int atoi PROT((char *));
#ifndef sgi
void srandom PROT((int));
#endif
#if !defined(_DCC) && !defined(__STDC__)
int chdir PROT((char *));
#endif
int gethostname PROT((char *, int));
void abort PROT((void));
int fflush PROT_STDIO((FILE *));
#ifndef __STDC__
int rmdir PROT((char *));
#ifndef _DCC
int unlink PROT((char *));
#endif
#endif
int fclose PROT_STDIO((FILE *));
#ifndef M_UNIX
#ifndef sgi
int system PROT((char *));
#endif
#endif
void qsort PROT((char *, int, int, int (*)()));
int fseek PROT_STDIO((FILE *, long, int));
int _flsbuf();
#ifndef __STDC__
int fork PROT((void));
#endif
#ifndef AMIGA_UNIX
int wait PROT((int *));
/* int execl PROT((char *, char *, ... )); */
#endif
int pipe PROT((int *));
int dup2 PROT((int, int));
#ifndef __STDC__
int vfork PROT((void));
#endif
void free PROT((char *));
void exit PROT((int));
#ifndef AMIGA_UNIX
/* int _exit PROT((int)); */
#endif
unsigned int alarm PROT((unsigned int));
#if ! defined(AMIGA_UNIX) && !defined(pyr) && !defined(linux) && !defined(__STDC__)
int ioctl PROT((int, ... ));
#endif
int close PROT((int));
#if !defined(AMIGA_UNIX) && !defined(__STDC__)
int write PROT((int, char *, int));
#endif
int _filbuf();
char *crypt PROT((char *, char *));
#ifdef sun
char *_crypt PROT((char *, char *));
#endif

long random PROT((void));

#ifndef _DCC
long strtol PROT((char *, char **, int));
#endif
#ifndef __STDC__
int link PROT((char *, char *));
#endif
#endif

struct object;
char *get_error_file PROT((char *));
void save_error PROT((char *, char *, int));
int file_size PROT((char *));
char *check_file_name PROT((char *, int));
void backend PROT((void));
void init_string_space PROT((void));
void trace_log();
void debug_message_value PROT((struct svalue *)),
print_local_commands(),
list_files PROT((char *));

void enter_program_hash PROT((struct program *));
void remove_program_hash PROT((struct program *));
struct program *lookup_program_hash PROT((char *));
char *show_otable_status PROT((int verbose));
void dumpstat PROT((void));
struct vector;
struct wiz_list;
char *query_load_av PROT((void));
void update_compile_av PROT((int));
char *describe_items PROT((struct svalue *arr,char *func,int live));
int match_string PROT((char *, char *));
int set_heart_beat PROT((struct object *, int));
struct object *get_empty_object PROT((int));
struct svalue;
char *add_string_status PROT((int verbose));
void throw_error PROT((void));
void set_living_name PROT((struct object *,char *));
void remove_living_name PROT((struct object *));
struct object *find_living_object PROT((char *));
int lookup_predef PROT((char *));
void yyerror PROT((char *));
int hashstr PROT((char *, int, int));
int lookup_predef PROT((char *));
struct object *environment PROT((struct svalue *));
struct object *first_inventory PROT((struct svalue *));
struct object *dump_trace PROT((int));
int parse_command PROT((char *, struct object *));
void init_num_args PROT((void));
void tell_object PROT((char *));
char *get_f_name PROT((int));
void startshutdowngame PROT((void));
int parse PROT((char *, struct svalue *, char *, struct svalue *, int));
int indent_program PROT((char *));
struct variable *find_status PROT((char *, int));
void free_prog PROT((struct program *, int));
char *stat_living_objects PROT((void));
char *heart_beat_status PROT((int verbose));
void opcdump PROT((void));
void slow_shut_down PROT((int));
void yyerror PROT((char *));
void load_first_objects PROT((void));
int random_number PROT((int));
void reset_object PROT((struct object *, int));
char *get_log_file PROT((char *));
int get_current_time PROT((void));
char *time_string PROT((int));
char *process_string PROT((char *));
void check_even_more_ref_counts PROT((int,char *));
int shadow_catch_message PROT((struct object *ob, char *str));
void remove_object_from_stack PROT((struct object *ob));
#if !defined(sgi) && !defined(linux)
int getpeername PROT((int, struct sockaddr *, int *));
/* void  shutdown PROT((int, int)); */
#endif
void compile_file PROT((void));

void set_inc_list PROT((struct svalue *sv));
#if !defined(ultrix) && !defined(M_UNIX) && !defined(sgi)\
 && !defined(AMIGA_UNIX)
extern int rename PROT((const char *,const char *));
#endif
void get_simul_efun PROT((struct svalue *));
char *query_simul_efun_file_name PROT((void));

#ifdef MUDWHO
void sendmudwhoinfo PROT((void));
void sendmudwhologout PROT((struct object *ob));
int rwhocli_setup PROT((char *server, char *serverpw, char *myname,
			char *comment));
int rwhocli_shutdown PROT((void));
int rwhocli_pingalive PROT((void));
int rwhocli_userlogin PROT((char *uid, char *name, int tim));
int rwhocli_userlogout PROT((char *uid));
#endif /* MUDWHO */
struct object *new_f_object(long);
struct svalue *map_get_default(struct vector *);
struct program *find_program(char *);
struct program *find_program2(char *);
struct object *find_hashed(char *);
struct vector *subtract_mapping(struct vector *,struct vector *);
struct vector *intersect_mapping(struct vector *,struct vector *);
int data_size(struct object *);
struct vector *allocate_mapping(struct vector *,struct vector *);
struct object *lookup_my_object_hash(char *);
#if 0
char *memchr(char *,char,int);
#endif
int restore_object(char *);
char *save_object();
char *restore_svalue(char *,struct svalue *);
void save_svalue(struct svalue *);
char *free_buf();
struct vector *allocate_list(struct vector *v);
struct vector *remove_list(struct vector *, struct svalue *);
struct vector *remove_mapping2(struct vector *, struct svalue *);
void remove_mapping(struct vector *, int);

#define BASEOF(ptr, str_type, field)  \
((struct str_type *)((char*)ptr - (char*)& (((struct str_type *)0)->field)))

#define NELEM(a) (sizeof (a) / sizeof ((a)[0]))

int dump_opcode_info();
void check_cost_for_instr(int);
void map_set_default(struct vector *v,struct svalue *s);

typedef void (*func_t) PROT((int,struct svalue *));
typedef void (*opcode_t) PROT((void));
void add_compiled(int instr);

char *string_print_formatted(char *,int,struct svalue *);
struct vector *filter_mapping (struct vector *p,
			       char *func,
			       struct object *ob,
			       struct svalue *extra);
struct vector *map_mapping (struct vector *arr,
			    char *func,
			    struct object *ob,
			    struct svalue *extra);

int is_eq(struct svalue *a, struct svalue *b);
int is_lt(struct svalue *a, struct svalue *b);
int is_gt(struct svalue *a, struct svalue *b);

char *getenv(char *);

#ifdef MALLOC_DEBUG
void check_sfltable();
#endif
