#include "efuns.h"
#include "array.h"
#include "list.h"

void f_l_aggregate(int num_arg,struct svalue *argp)
{
  int i;
  struct vector *v, *w;

  v = allocate_array(num_arg);
  for (i=0; i < num_arg; i++)
    assign_svalue_no_free(&v->item[i], argp+i);
  pop_n_elems(num_arg);
  w=allocate_array(1);
  w->item[0].type=T_ALIST_PART;
  w->item[0].u.vec=v;
  order_alist(w);
  push_list(w);
  w->ref--;
}

void f_m_list(int num_arg,struct svalue *argp)
{
  struct vector *v;

  v = sp->u.vec;
  check_map_for_destr(v);
  v = v->item[0].u.vec;
  v = allocate_list(slice_array(v, 0, v->size - 1));
  pop_stack();
  push_list(v);
  v->ref--;			/* Will make ref count == 1 */
}

void f_l_delete(int num_arg,struct svalue *argp)
{
  struct vector *v;
  check_map_for_destr((sp-1)->u.vec);
  v=remove_list((sp-1)->u.vec,sp);
  pop_stack();
  push_list(v);
  v->ref--;			/* Will make ref count == 1 */
}

void f_mklist(int num_arg,struct svalue *argp)
{
  struct vector *v;
  check_for_destr(sp->u.vec);
  v=mklist(sp->u.vec);
  pop_stack();
  push_list(v);
  v->ref--;
}
