%{
# line 3 "prelang.y"
/* The above line is to give proper line number references. Please mail me
 * if your compiler complains about it.
 */
/*
 * This is the grammar definition of LPC. The token table is built
 * automatically by make_func. The lang.y is constructed from this file,
 * the generated token list and post_lang.y. The reason of this is that there
 * is no #include-statment that yacc recognizes.
 */
#include <string.h>
#include <stdio.h>
#include <memory.h>
#if defined(sun)
#include <alloca.h>
#endif

#include <setjmp.h>
#include "config.h"
#include "lint.h"
#include "simul_efun.h"
#include "interpret.h"
#include "array.h"
#include "object.h"
#include "exec.h"
#ifndef F_MAX_INSTR
#include "lang.h"
#endif
#include "instrs.h"
#include "incralloc.h"
#include "dumpstat.h"
#include "operators.h"
#include "stralloc.h"
#include "main.h"
#include "las.h"

extern struct program fake_prog;

#define YYMAXDEPTH	600

int islocal PROT((char *));

extern struct mem_block mem_block[NUMAREAS];


#define align(x) (((x) + 3) & ~3)
#define FUN_IS_VARARGS 0x40000000

/*
 * If the type of the function is given, then strict types are
 * checked and required.
 */
int exact_types;
extern int pragma_strict_types;	/* Maintained by lex.c */
extern int pragma_save_types;	/* Also maintained by lex.c */
int approved_object;		/* How I hate all these global variables */

int total_num_prog_blocks, total_prog_block_size;

extern int lasdebug;
extern struct vector *current_switch_mapping;
extern int *break_stack;
extern int current_break,break_stack_size;
extern int *continue_stack;
extern int current_continue,continue_stack_size;

extern int comp_stackp;
extern int num_parse_error;
extern int d_flag;
static int current_type;
node *init_node=0;


static struct program NULL_program; /* marion - clean neat empty struct */

void push_locals();
void pop_locals();
void push_break_stack();
void pop_break_stack(int);
void push_continue_stack();
void pop_continue_stack(int);

void epilog();
int check_declared PROT((char *str));
static void prolog();
void free_all_local_names(),
    add_local_name PROT((char *, int)), smart_log PROT((char *, int, char *));
extern int yylex();
int verify_declared PROT((char *));
static void copy_variables();
static void copy_functions PROT((struct program *, int type,int offset));
void type_error PROT((char *, int));
int insert_efun_call(int f,int args);
void insert_pop_stack();
void pop_local_names();
char *get_type_name(int);

extern int current_line;
/*
 * 'inherit_file' is used as a flag. If it is set to a string
 * after yyparse(), this string should be loaded as an object,
 * and the original object must be loaded again.
 */
extern char *current_file, *inherit_file;

/*
 * The names and types of arguments and auto variables.
 */
char **local_names;
unsigned short *type_of_locals;
int current_number_of_locals = 0;

struct program *prog;	/* Is returned to the caller of yyparse */

/*
 * Return the index of the function found, otherwise -1.
 */
int defined_function(char *s)
{
  int e;
  struct function_p *funp;
  struct function *fun;
  char *interned;

  /* Only search if amongst strings */
  if (interned = findstring(s))
  {
    for (e=mem_block[A_FUNCTION_PTRS].current_size/sizeof(struct function_p)-1
	 ;e>=0;e--)
    {
      funp=FUNCTIONP(e);
      if (funp->flags & NAME_HIDDEN) continue;
      fun=INHERIT(funp->prog)->prog->functions+funp->fun;
      /* Pointer comparison is possible since we use unique strings */
      if (fun->name == interned) return e;
    }
  }
  return -1;
}

int low_reference_inherited_function(int e,char *function_name)
{
  struct function_p funp;
  struct program *p;
  int i,d;

  p=fake_prog.inherit[e].prog;
  i=find_shared_string_function(function_name,p);
  if(i==-1) return i;

  if(p->function_ptrs[i].flags & (NAME_UNDEFINED|NAME_HIDDEN))
    return -1;

  funp=p->function_ptrs[i];
  funp.prog=e;
  funp.flags|=NAME_HIDDEN;

  for(d=0;d<fake_prog.num_function_ptrs;d++)
  {
    struct function_p *fp;
    fp=fake_prog.function_ptrs+d;

    if(!memcmp((char *)fp,(char *)&funp,sizeof funp)) return d;
  }

  add_to_mem_block(A_FUNCTION_PTRS,(char *)&funp,sizeof funp);
  return fake_prog.num_function_ptrs;
}

int reference_inherited_function(char *super_name,char *function_name)
{
  struct program *p;
  int e,i;

  setup_fake_program();

  if(function_name=findstring(function_name))
  {
    for(e=fake_prog.num_inherited-1;e>0;e--)
    {
      if(fake_prog.inherit[e].inherit_level!=1) continue;
      p=fake_prog.inherit[e].prog;
      if(super_name)
      {
	int l;
	l=strlen(p->name);
	if(l<strlen(super_name)) continue;
	if(strncmp(super_name,p->name+l-strlen(super_name),strlen(super_name)))
	  continue;
      }

      i=low_reference_inherited_function(e,function_name);
      if(i==-1) continue;
      return i;
    }
  }
  return -1;
}

/*
 * Define a new function. Note that this function is called at least twice
 * for alll function definitions. First as a prototype, then as the real
 * function. Thus, there are tests to avoid generating error messages more
 * than once by looking at (flags & NAME_PROTOTYPE).
 */
static int define_new_function(char *name,
			       int num_arg,
			       int num_local,
			       int offset,
			       int flags,
			       int type)
{
  int num;
  struct function fun,*func;
  struct function_p fun_p,*funp;
  unsigned short argument_start_index;
  extern int pragma_all_inline;
  num = defined_function(name);

  if(pragma_all_inline)
    type|=TYPE_MOD_INLINE;
  if (num >= 0)
  {
    /*
     * The function was already defined. It may be one of several reasons:
     *
     * 1.	There has been a prototype.
     * 2.	There was the same function defined by inheritance.
     * 3.	This function has been called, but not yet defined.
     * 4.	The function is doubly defined.
     * 5.	A "late" prototype has been encountered.
     */
    funp = FUNCTIONP(num);
    if (!(funp->flags & NAME_UNDEFINED) &&
	!(flags & NAME_PROTOTYPE) &&
	!(funp->flags & NAME_INHERITED))
    {
      char *p = (char *)allocaX(80 + strlen(name));
      sprintf(p, "Redeclaration of function %s.", name);
      yyerror(p);
      return num;
    }

    /*
     * It was either an undefined but used funtion, or an inherited
     * function. In both cases, we now consider this to be THE new
     * definition. It might also have been a prototype to an already
     * defined function.
     *
     * Check arguments only when types are supposed to be tested,
     * and if this function really has been defined already.
     *
     * 'nomask' functions may not be redefined.
     */
    if ((funp->type & TYPE_MOD_NO_MASK) &&
	!(funp->flags & NAME_PROTOTYPE) &&
	!(flags & NAME_PROTOTYPE))
    {
      char *p = (char *)allocaX(80 + strlen(name));
      sprintf(p, "Illegal to redefine 'nomask' function \"%s\"",name);
      yyerror(p);
    }

    func=INHERIT(funp->prog)->prog->functions+funp->fun;

    if (exact_types && funp->type != TYPE_UNKNOWN)
    {
      int i;
      if (func->num_arg != num_arg && !(funp->type & TYPE_MOD_VARARGS))
      {
	yyerror("Incorrect number of arguments.");
      }else if (!(funp->flags & NAME_STRICT_TYPES)){
	yyerror("Called function not compiled with type testing.");
      }else{
	/* Now check that argument types wasn't changed. */
	for (i=0; i < num_arg; i++)
	{
	  /* oops, gotta do something here */
	}
      }
    }

    /* If it was yet another prototype, then simply return. */
    if (flags & NAME_PROTOTYPE)
      return num;

#ifdef DEBUG
    if(lasdebug)
    {
      fprintf(stderr,"Defining function '%s'\n",name);
    }
#endif

    if(funp->prog!=0)
    {
      fun.name=make_shared_string(name);
      funp->fun=mem_block[A_FUNCTIONS].current_size/sizeof(struct function);
      funp->prog=0;
      add_to_mem_block(A_FUNCTIONS,(char *)&fun,sizeof fun);
      func=INHERIT(funp->prog)->prog->functions+funp->fun;
    }

    func->num_arg=num_arg;
    func->num_local=num_local;
    func->offset=offset;

    funp->flags = flags;
    funp->type = type;
    funp->prog=0;

    if (exact_types) funp->flags |= NAME_STRICT_TYPES;
    return num;
  }
  
  fun.name = make_shared_string(name);
  fun.offset = offset;
  fun.num_arg = num_arg;
  fun.num_local = num_local;

  num = mem_block[A_FUNCTIONS].current_size / sizeof fun;
  /* Number of local variables will be updated later */
  add_to_mem_block(A_FUNCTIONS, (char *)&fun, sizeof fun);

  fun_p.flags = flags;
  fun_p.type = type;
  fun_p.fun=num;
  fun_p.prog=0;
  if (exact_types)
    fun_p.flags |= NAME_STRICT_TYPES;

  num = mem_block[A_FUNCTION_PTRS].current_size / sizeof fun_p;
  /* Number of local variables will be updated later */
  add_to_mem_block(A_FUNCTION_PTRS, (char *)&fun_p, sizeof fun_p);

  if (exact_types == 0 || num_arg == 0)
  {
    argument_start_index = INDEX_START_NONE;
  } else {
    int i;

    /*
     * Save the start of argument types.
     */
    argument_start_index =
      mem_block[A_ARGUMENT_TYPES].current_size /
	sizeof (unsigned short);
    for (i=0; i < num_arg; i++)
    {
      add_to_mem_block(A_ARGUMENT_TYPES, (char *)&type_of_locals[i],
		       sizeof type_of_locals[i]);
    }
  }
  add_to_mem_block(A_ARGUMENT_INDEX, (char *)&argument_start_index,
		   sizeof argument_start_index);
  return num;
}

/* argument must be a shared string */
static void define_variable(char *name,int type,int flags)
{
  struct variable dummy;
  int n;

  n = check_declared(name);
  if (n != -1 && (VARIABLE(n)->type & TYPE_MOD_NO_MASK))
  {
    char *p = (char *)allocaX(80 + strlen(name));
    sprintf(p, "Illegal to redefine 'nomask' variable \"%s\"", name);
    yyerror(p);
  }
  dummy.name = copy_shared_string(name);
  dummy.type = type;
  dummy.flags = flags;
  add_to_mem_block(A_VARIABLES, (char *)&dummy, sizeof dummy);
}

void fix_comp_stack(int sp)
{
  if(comp_stackp>sp)
  {
    yyerror("Compiler stack fixed.");
    comp_stackp=sp;
  }else if(comp_stackp<sp){
    fatal("Compiler stack frame underflow.");
  }
}

%}

%token F_ADD_256
